;
;MSX Gen80 & Compass adapted ION v1.0 include file, by Grauw.
;============================================================
;*** Use "bcall routine" instead of "bcall(routine)"
;*** Use a minimal labellength of 15 characters.
;*** This routine replaces TI83ASM.INC
;
;*** Please fill in the TI-83 version you want to generate the program for.
;    (I suggest you move this constant to the main file)
;
TI83:	equ	0	;0=TI-83, 1=TI-83+
;
;



; The Ion Include File by Dan Englender
;
;----> Safe Memory Areas
; saferam1 = 768 bytes (apdram)
; saferam2 = 531 bytes (statram)
; saferam3 = 128 bytes (textmem)
; saferam4 = 66 bytes (ops)
; saferam5 = 10 bytes (imathptrs)


bcall:	MACRO	@routine
	IF	TI83=0	;If TI-83 define this...
	call	@routine
	ELSE		;                ;If TI-83+ define this...
	rst	#28
	dw	@routine
	ENDIF
	ENDM
bjump:	MACRO	@routine
	IF	TI83=0	;If TI-83 define this...
	jp	@routine
	ELSE		;                ;If TI-83+ define this...
	call	#50
	dw	@routine
	ENDIF
	ENDM

	IF	TI83=0	;If TI-83 define these...
usermemoff	equ	$8565
progstart	equ	9327h
libstart	equ	$0002
saferam1	equ	8265h
saferam2	equ	858Fh
saferam3	equ	80C9h
saferam4	equ	8039h
_getcsc	equ	$4014
_homeup	equ	$4775
_newline	equ	$473D
_darkline	equ	$4AE0
_indicatorOff	equ	$4795
_indicatorOn	equ	$4791
_cleargbuf	equ	515Bh
_copygbuf	equ	4B9Ch
_clrlcdf	equ	4755h
_cleartextshad	equ	4765h
_clrscr	equ	4759h
_clrscrf	equ	475Dh
_iline	equ	4AE4h
_ipoint	equ	4AE8h
_ldhlind	equ	4000h
_divhlby10	equ	4008h
_cphlde	equ	4004h
_disphl	equ	4709h
_divhlbya	equ	400Ch
_hltimes9	equ	4146h
_vputmap	equ	477Dh
_vputs	equ	4781h
_vputsn	equ	4785h
_putmap	equ	4701h
_puts	equ	470Dh
_putps	equ	4715h
_putc	equ	4705h
_getkey	equ	4CFEh
_getk	equ	4A18h
_rcly	equ	4EE0h
_rclx	equ	4EE8h
_memfree	equ	441Ah
_chksysvar	equ	442Ah
_findsym	equ	442Eh
_creategdb	equ	4486h
_createprog	equ	448Ah
_createreal	equ	4452h
_createstring	equ	4472h
_delvar	equ	44AAh
_insertmem	equ	4432h
_deletemem	equ	44B2h
_lcdbusy	equ	4066h
op1	equ	8039h
op2	equ	8044h
op3	equ	804Fh
op4	equ	805Ah
op5	equ	8065h
op6	equ	8070h
imathptr1	equ	8094h
imathptr2	equ	8096h
imathptr3	equ	8098h
imathptr4	equ	809Ah
imathptr5	equ	809Ch
progptr	equ	9319h
cmdshad	equ	9157h
plotsscreen	equ	8E29h
symtable	equ	$FE6E
currow	equ	800Ch
curcol	equ	800Dh
pencol	equ	8252h
penrow	equ	8253h
curgy	equ	886Dh
curgx	equ	886Eh
_op1toop2	equ	$418E
_op1toop3	equ	$417E
_op1toop4	equ	$416E
_op1toop5	equ	$41BE
_op1toop6	equ	$41BA
_op2toop1	equ	$41C2
_op2toop3	equ	$41F6
_op2toop4	equ	$4172
_op2toop5	equ	$41B2
_op2toop6	equ	$41B6
_op3toop1	equ	$41A2
_op3toop2	equ	$417A
_op3toop4	equ	$416A
_op3toop5	equ	$41AE
_op4toop1	equ	$419A
_op4toop2	equ	$4176
_op4toop3	equ	$41FA
_op4toop5	equ	$41AA
_op4toop6	equ	$4202
_op5toop1	equ	$419E
_op5toop2	equ	$4182
_op5toop3	equ	$41FE
_op5toop4	equ	$418A
_op5toop6	equ	$4186
_op6toop1	equ	$4196
_op6toop2	equ	$4192
_op6toop5	equ	$41A6
_op1exop2	equ	$4306
_op1exop3	equ	$42FE
_op1exop4	equ	$4302
_op1exop5	equ	$42EE
_op1exop6	equ	$42F2
_op2exop4	equ	$42F6
_op2exop5	equ	$42FA
_op2exop6	equ	$42E6
_op5exop6	equ	$42EA
_op1set0	equ	$4286
_op1set1	equ	$4232
_op1set2	equ	$4242
_op1set3	equ	$423A
_op1set4	equ	$4236
_op2set0	equ	$4282
_op2set1	equ	$4252
_op2set2	equ	$4246
_op2set3	equ	$422E
_op2set4	equ	$422A
_op2set5	equ	$4222
_op2set8	equ	$421E
_op2setA	equ	$4226
_op3set0	equ	$427E
_op3set1	equ	$421A
_op3set2	equ	$423E
_op4set0	equ	$427A
_op4set1	equ	$4216
_op5set0	equ	$4276
_pushop1	equ	$454A
_pushop3	equ	$4542
_popop1	equ	$44E6
_popop3	equ	$44E2
_setxxop1	equ	$4A74
_setxxop2	equ	$4A78
_setxxxxop2	equ	$4A7C
_dispop1a	equ	$51D4
_mov9toop1	equ	$4206

	ELSE		;                ;If TI-83+ define this...
_getcsc	equ	4018h
_darkline	equ	$47DD
_darkpoint	equ	$47F2
appBackupScreen	equ	$9872	; 768 bytes
tempSwapArea	equ	$82A5
usermemoff	equ	$89EC
libstart	equ	$0004
progstart	equ	9D95h
saferam1	equ	9872h
saferam2	equ	858fh
saferam3	equ	80C9h
saferam4	equ	8039h
_homeup	equ	$4558
_newline	equ	$452E
_cleargbuf	equ	4BD0h
_indicatorOn	equ	456Dh
_indicatorOff	equ	4570h
_copygbuf	equ	486Ah
_clrlcdf	equ	4540h
_cleartextshad	equ	454Ch
_clrscr	equ	4543h
_clrscrf	equ	4546h
_iline	equ	47E0h
_ipoint	equ	47E3h
;_ldHLind          equ 4000h
_divhlby10	equ	400Fh
_cphlde	equ	400Ch
_disphl	equ	4507h
_divhlbya	equ	4012h
_hltimes9	equ	40F9h
_vputmap	equ	455Eh
_vputs	equ	4561h
_vputsn	equ	4564h
_putmap	equ	4501h
_puts	equ	450Ah
_putps	equ	4510h
_putc	equ	4504h
_getkey	equ	4972h
_getk	equ	4744h
;_RCLY            equ 4EE0h
;_RCLX            equ 4EE8h
_memfree	equ	$42E5
_chksysvar	equ	42F1h
_findsym	equ	42F4h
;_CREATEGDB       equ 4486h
;_CREATEREAL      equ 4452h
;_CREATESTRNG     equ 4472h
_createprog	equ	$4339
_createprotprog	equ	$4E6D
_delvar	equ	4351h
_insertmem	equ	42F7h
_deletemem	equ	4357h
_lcdbusy	equ	4051h
op1	equ	8478h
op2	equ	8483h
op3	equ	8499h
op4	equ	8499h
op5	equ	84A4h
op6	equ	84AFh
imathptr1	equ	84D3h
imathptr2	equ	84D5h
imathptr3	equ	84D7h
imathptr4	equ	84D9h
imathptr5	equ	84DBh
progptr	equ	9830h
cmdshad	equ	966Eh
plotsscreen	equ	9340h
symtable	equ	$FE6E
currow	equ	844Bh
curcol	equ	844Ch
pencol	equ	86D7h
penrow	equ	86D8h
curgy	equ	8D18h
curgx	equ	8D19h
_cpop1op2	equ	$4111
_op3toop4	equ	$4114
_op1toop4	equ	$4117
_op2toop4	equ	$411A
_op4toop2	equ	$411D
_op3toop2	equ	$4120
_op1toop3	equ	$4123
_op5toop2	equ	$4126
_op5toop6	equ	$4129
_op5toop4	equ	$412C
_op1toop2	equ	$412F
_op6toop2	equ	$4132
_op6toop1	equ	$4135
_op4toop1	equ	$4138
_op5toop1	equ	$413B
_op3toop1	equ	$413E
_op6toop5	equ	$4141
_op4toop5	equ	$4144
_op3toop5	equ	$4147
_op2toop5	equ	$414A
_op2toop6	equ	$414D
_op1toop6	equ	$4150
_op1toop5	equ	$4153
_op2toop1	equ	$4156
_op2toop3	equ	$416E
_op4toop3	equ	$4171
_op5toop3	equ	$4174
_op4toop6	equ	$4177
_zeroop1	equ	$41C5
_zeroop2	equ	$41C8
_zeroop3	equ	$41CB
_setxxop1	equ	$478C
_setxxop2	equ	$478F
_setxxxxop2	equ	$4792
_dispop1a	equ	4BF7h
_mov9toop1	equ	$417A
_pushop1	equ	$43C9
_popop1	equ	$437E
	ENDIF

grbuf	equ	plotsscreen
graph_mem	equ	plotsscreen
gbuf	equ	plotsscreen
sram	equ	saferam1
apdram	equ	saferam1
statram	equ	saferam2
statvars	equ	saferam2
vat	equ	progptr
saferam5	equ	imathptr1

;-----> Ion Functions
lVectors	equ	cmdshad+80
ionVersion	equ	lVectors
ionRandom	equ	lVectors+3
ionPutSprite	equ	lVectors+6
ionLargeSprite	equ	lVectors+9
ionGetPixel	equ	lVectors+12
ionFastCopy	equ	lVectors+15
ionDetect	equ	lVectors+18
ionDecompress	equ	lVectors+21

trigflags	EQU	0	; IY OFFSET VALUE
trigdeg	EQU	2
;
plotflags	EQU	2	; IY OFFSET VALUE
plotloc	EQU	1
plotdisp	EQU	2
;
grfmodeflags	EQU	2	; IY OFFSET VALUE
grffuncm	EQU	4
grfpolarm	EQU	5
grfparamm	EQU	6
grfrecurm	EQU	7
;
graphflags	EQU	3	; IY OFFSET VALUE
graphdraw	EQU	0
graphcursor	EQU	2
;
grfdbflags	EQU	4	; IY OFFSET VALUE
grfdot	EQU	0
grfsimul	EQU	1
grfgrid	EQU	2
grfpolar	EQU	3
grfnocoord	EQU	4
grfnoaxis	EQU	5
grflabel	EQU	6
;
textflags	EQU	5	; IY OFFSET VALUE
textEraseBelow	EQU	1
textScrolled	EQU	2
textInverse	EQU	3
;
onflags	EQU	9	; IY OFFSET VALUE
onRunning	EQU	3
onInterrupt	EQU	4
;
statflags	EQU	9	; IY OFFSET VALUE
statsvalid	EQU	6
;
fmtflags	EQU	10	; IY OFFSET VALUE
fmtExponent	EQU	0
fmtEng	EQU	1
;
nummode	EQU	10	; IY OFFSET VALUE
FMTREAL	EQU	5
FMTRECT	EQU	6
FMTPOLAR	EQU	7
;
curflags	EQU	12	; IY OFFSET VALUE
curAble	EQU	2
curOn	EQU	3
curLock	EQU	4
;
appflags	EQU	13	; IY OFFSET VALUE
appTextSave	EQU	1
appAutoScroll	EQU	2
;
PLOTFLAG2	EQU	17	; IY OFFSET VALUE
EXPR_PARAM	EQU	3
EXPR_WRITING	EQU	4
;
indicflags	EQU	18	; IY OFFSET VALUE
indicRun	EQU	0
indicOnly	EQU	2
;
shiftflags	EQU	18	; IY OFFSET VALUE
shift2nd	EQU	3
shiftAlpha	EQU	4
shiftALock	EQU	6
;
tblflags	EQU	19	; IY OFFSET VALUE
AutoFill	EQU	4
AutoCalc	EQU	5
;
sgrflags	EQU	20	; IY OFFSET VALUE
grfSplit	EQU	0
VertSplit	EQU	1
WRITE_ON_GRAPH	EQU	4
textwrite	EQU	7
;
asm_flag1	EQU	33	; IY OFFSET VALUE
asm_flag1_0	EQU	0
asm_flag1_1	EQU	1
asm_flag1_2	EQU	2
asm_flag1_3	EQU	3
asm_flag1_4	EQU	4
asm_flag1_5	EQU	5
asm_flag1_6	EQU	6
asm_flag1_7	EQU	7
;
asm_flag2	EQU	34	; IY OFFSET VALUE
asm_flag2_0	EQU	0
asm_flag2_1	EQU	1
asm_flag2_2	EQU	2
asm_flag2_3	EQU	3
asm_flag2_4	EQU	4
asm_flag2_5	EQU	5
asm_flag2_6	EQU	6
asm_flag2_7	EQU	7
;
asm_flag3	EQU	35	; IY OFFSET VALUE
asm_flag3_0	EQU	0
asm_flag3_1	EQU	1
asm_flag3_2	EQU	2
asm_flag3_3	EQU	3
asm_flag3_4	EQU	4
asm_flag3_5	EQU	5
asm_flag3_6	EQU	6
asm_flag3_7	EQU	7

